org.springframework.http.converter.json

## Class KotlinSerializationJsonHttpMessageConverter

- java.lang.Object
- - org.springframework.http.converter.AbstractHttpMessageConverter<T>
  - - org.springframework.http.converter.AbstractGenericHttpMessageConverter<Object>
    - - org.springframework.http.converter.json.KotlinSerializationJsonHttpMessageConverter

- All Implemented Interfaces:
    GenericHttpMessageConverter<Object>, HttpMessageConverter<Object>

      public class KotlinSerializationJsonHttpMessageConverter
      extends AbstractGenericHttpMessageConverter<Object>

  Implementation of `HttpMessageConverter` that can read and write JSON using kotlinx.serialization.

  This converter can be used to bind `@Serializable` Kotlin classes, open polymorphic serialization is not supported. It supports `application/json` and `application/*+json` with various character sets, `UTF-8` being the default.

  Since:
    5.3
  Author:
    Andreas Ahlenstorf, Sebastien Deleuze, Juergen Hoeller

- - ### Field Summary

    - ### Fields inherited from class org.springframework.http.converter.AbstractHttpMessageConverter

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `KotlinSerializationJsonHttpMessageConverter()` Construct a new `KotlinSerializationJsonHttpMessageConverter` with the default configuration.
    `KotlinSerializationJsonHttpMessageConverter(kotlinx.serialization.json.Json json)` Construct a new `KotlinSerializationJsonHttpMessageConverter` with a custom configuration.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canRead(Type type, Class<?> contextClass, MediaType mediaType)` Indicates whether the given type can be read by this converter.
    `boolean` | `canWrite(Type type, Class<?> clazz, MediaType mediaType)` Indicates whether the given class can be written by this converter.
    `Object` | `read(Type type, Class<?> contextClass, HttpInputMessage inputMessage)` Read an object of the given type form the given input message, and returns it.
    `protected Object` | `readInternal(Class<?> clazz, HttpInputMessage inputMessage)` Abstract template method that reads the actual object.
    `protected boolean` | `supports(Class<?> clazz)` Indicates whether the given class is supported by this converter.
    `protected void` | `writeInternal(Object object, Type type, HttpOutputMessage outputMessage)` Abstract template method that writes the actual body.

    - ### Methods inherited from class org.springframework.http.converter.AbstractGenericHttpMessageConverter

      `write, writeInternal`

    - ### Methods inherited from class org.springframework.http.converter.AbstractHttpMessageConverter

      `addDefaultHeaders, canRead, canRead, canWrite, canWrite, getContentLength, getDefaultCharset, getDefaultContentType, getSupportedMediaTypes, read, setDefaultCharset, setSupportedMediaTypes, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.http.converter.HttpMessageConverter

      `canRead, canWrite, getSupportedMediaTypes, getSupportedMediaTypes, read, write`

- - ### Constructor Detail

    - #### KotlinSerializationJsonHttpMessageConverter

          public KotlinSerializationJsonHttpMessageConverter()

      Construct a new `KotlinSerializationJsonHttpMessageConverter` with the default configuration.

    - #### KotlinSerializationJsonHttpMessageConverter

          public KotlinSerializationJsonHttpMessageConverter(kotlinx.serialization.json.Json json)

      Construct a new `KotlinSerializationJsonHttpMessageConverter` with a custom configuration.

  - ### Method Detail

    - #### supports

          protected boolean supports(Class<?> clazz)

      Description copied from class: `AbstractHttpMessageConverter`
      Indicates whether the given class is supported by this converter.
      Overrides:
        `supports` in class `AbstractGenericHttpMessageConverter<Object>`
      Parameters:
        `clazz` - the class to test for support
      Returns:
        `true` if supported; `false` otherwise

    - #### canRead

          public boolean canRead(Type type,
                                 @Nullable
                                 Class<?> contextClass,
                                 @Nullable
                                 MediaType mediaType)

      Description copied from interface: `GenericHttpMessageConverter`
      Indicates whether the given type can be read by this converter. This method should perform the same checks as `HttpMessageConverter.canRead(Class, MediaType)` with additional ones related to the generic type.
      Specified by:
        `canRead` in interface `GenericHttpMessageConverter<Object>`
      Overrides:
        `canRead` in class `AbstractGenericHttpMessageConverter<Object>`
      Parameters:
        `type` - the (potentially generic) type to test for readability
        `contextClass` - a context class for the target type, for example a class in which the target type appears in a method signature (can be `null`)
        `mediaType` - the media type to read, can be `null` if not specified. Typically, the value of a `Content-Type` header.
      Returns:
        `true` if readable; `false` otherwise

    - #### canWrite

          public boolean canWrite(@Nullable
                                  Type type,
                                  Class<?> clazz,
                                  @Nullable
                                  MediaType mediaType)

      Description copied from interface: `GenericHttpMessageConverter`
      Indicates whether the given class can be written by this converter.

      This method should perform the same checks as `HttpMessageConverter.canWrite(Class, MediaType)` with additional ones related to the generic type.

      Specified by:
        `canWrite` in interface `GenericHttpMessageConverter<Object>`
      Overrides:
        `canWrite` in class `AbstractGenericHttpMessageConverter<Object>`
      Parameters:
        `type` - the (potentially generic) type to test for writability (can be `null` if not specified)
        `clazz` - the source object class to test for writability
        `mediaType` - the media type to write (can be `null` if not specified); typically the value of an `Accept` header.
      Returns:
        `true` if writable; `false` otherwise

    - #### read

          public final Object read(Type type,
                                   @Nullable
                                   Class<?> contextClass,
                                   HttpInputMessage inputMessage)
                            throws IOException,
                                   HttpMessageNotReadableException

      Description copied from interface: `GenericHttpMessageConverter`
      Read an object of the given type form the given input message, and returns it.
      Parameters:
        `type` - the (potentially generic) type of object to return. This type must have previously been passed to the `canRead` method of this interface, which must have returned `true`.
        `contextClass` - a context class for the target type, for example a class in which the target type appears in a method signature (can be `null`)
        `inputMessage` - the HTTP input message to read from
      Returns:
        the converted object
      Throws:
        `IOException` - in case of I/O errors
        `HttpMessageNotReadableException` - in case of conversion errors

    - #### readInternal

          protected final Object readInternal(Class<?> clazz,
                                              HttpInputMessage inputMessage)
                                       throws IOException,
                                              HttpMessageNotReadableException

      Description copied from class: `AbstractHttpMessageConverter`
      Abstract template method that reads the actual object. Invoked from `AbstractHttpMessageConverter.read(java.lang.Class<? extends T>, org.springframework.http.HttpInputMessage)`.
      Specified by:
        `readInternal` in class `AbstractHttpMessageConverter<Object>`
      Parameters:
        `clazz` - the type of object to return
        `inputMessage` - the HTTP input message to read from
      Returns:
        the converted object
      Throws:
        `IOException` - in case of I/O errors
        `HttpMessageNotReadableException` - in case of conversion errors

    - #### writeInternal

          protected final void writeInternal(Object object,
                                             @Nullable
                                             Type type,
                                             HttpOutputMessage outputMessage)
                                      throws IOException,
                                             HttpMessageNotWritableException

      Description copied from class: `AbstractGenericHttpMessageConverter`
      Abstract template method that writes the actual body. Invoked from `AbstractGenericHttpMessageConverter.write(T, java.lang.reflect.Type, org.springframework.http.MediaType, org.springframework.http.HttpOutputMessage)`.
      Specified by:
        `writeInternal` in class `AbstractGenericHttpMessageConverter<Object>`
      Parameters:
        `object` - the object to write to the output message
        `type` - the type of object to write (may be `null`)
        `outputMessage` - the HTTP output message to write to
      Throws:
        `IOException` - in case of I/O errors
        `HttpMessageNotWritableException` - in case of conversion errors